[build-system]
requires = ["hatchling"]
build-backend = "hatchling.build"

[project]
name = "wurker"
dynamic = ["version"]
description = 'The superpowered love child of cron and supervisor.'
readme = "README.md"
requires-python = ">=3.10"
license = "MIT"
keywords = []
authors = [
  { name = "Joseph Edwards VIII", email = "jedwards8th@gmail.com" },
]
classifiers = [
  "Development Status :: 4 - Beta",
  "Programming Language :: Python",
  "Programming Language :: Python :: 3.10",
  "Programming Language :: Python :: 3.11",
  "Programming Language :: Python :: 3.12",
  "Programming Language :: Python :: Implementation :: CPython",
  "Programming Language :: Python :: Implementation :: PyPy",
]
dependencies = [
  "coverage[toml]>=6.5",
  "click",
  "pytest",
  "mysqlclient",
  "SQLAlchemy>=2.0",
  "sqlalchemy-utils",
  "croniter",
  "python-dateutil",
  "fabric",
  "Flask",
  "Jinja2",
  "psutil",
  "watchdog",
  "gunicorn",
  "python-slugify>=7.0.0",
  "requests",
  "tomlkit",
  "alembic",
  "log9er",
  'psycopg2-binary',
  'platformdirs',
]

[project.urls]
Documentation = "https://wurker-hatch-joseph8th-c60d52520b93f67b0292339f4314cef826907222.gitlab.io/"
Issues = "https://gitlab.com/joseph8th/wurker-hatch/-/issues"
Source = "https://gitlab.com/joseph8th/wurker-hatch/"

[project.scripts]
wurk = "wurker.cli:wurk"
wurker-ui = "wurker.ui.flask_run:main"

[tool.hatch.build.targets.wheel]
packages = ["src/wurker"]
include = ["wurker/etc/**/*"]
exclude = ["**/node_modules", "**/node_modules/**/*", "docs/**/*"]

[tool.hatch.version]
path = "src/wurker/__about__.py"

[tool.hatch.envs.default]
dependencies = [
  "coverage[toml]>=6.5",
  "pytest",
  "mysqlclient",
  "SQLAlchemy>=2.0",
  "sqlalchemy-utils",
  "croniter",
  "python-dateutil",
  "fabric",
  "Flask",
  "Jinja2",
  "psutil",
  "watchdog",
  "gunicorn",
  "python-slugify>=7.0.0",
  "requests",
  "tomlkit",
  "click-man",
  "alembic",
  "log9er",
  'psycopg2-binary',
  'platformdirs',
]

[tool.hatch.envs.default.scripts]
test = "pytest {args:tests}"
test-cov = "coverage run -m pytest {args:tests}"
cov-report = [
  "- coverage combine",
  "coverage report",
]
cov = [
  "test-cov",
  "cov-report",
]

[[tool.hatch.envs.all.matrix]]
python = ["3.11", "3.12"]

[tool.hatch.envs.types]
dependencies = [
  "mypy>=1.0.0",
]
[tool.hatch.envs.types.scripts]
check = "mypy --install-types --non-interactive {args:src/wurker tests}"

[tool.coverage.run]
source_pkgs = ["wurker", "tests"]
branch = true
parallel = true
omit = [
  "src/wurker/__about__.py",
]

[tool.coverage.paths]
wurker = ["src/wurker", "*/wurker/src/wurker"]
tests = ["tests", "*/wurker/tests"]

[tool.coverage.report]
exclude_lines = [
  "no cov",
  "if __name__ == .__main__.:",
  "if TYPE_CHECKING:",
]
